<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 2.2: Data Types and Sizes</title>
<link href="sx5a.html" rev=precedes>
<link href="sx5c.html" rel=precedes>
<link href="sx5.html" rev=subdocument>
</head>
<body>
<H2>section 2.2: Data Types and Sizes</H2>

page 36
<p>If you can look at this list of
``a few basic types in C''
and say to yourself,
``Oh, how simple, there are only a few types,
I won't have to worry much about choosing among them,''
you'll have an easy time with declarations.
(Some masochists wish that the type system were more complicated
so that you could specify more things about each variable,
but those of us who would rather not have to specify these
extra things each time are glad that we don't have to.)
</p><p>Note that the basic types are defined as having
<em>at least</em> a certain size.
There is no specification that
a <TT>short int</TT> will be exactly 16 bits,
or that a <TT>long int</TT> will be exactly 32 bits.
Some programmers become obsessed with knowing exactly what 
sizes things will be in various situations,
and write programs which depend on things having certain sizes.
Exact sizes are occasionally important,
but most of the time we can sidestep size issues
and let the compiler do most of the worrying.
</p><p>Most of the simple variables in most programs are of types 
<TT>int</TT>, <TT>long int</TT>, or <TT>double</TT>.
Typically, we'll use <TT>int</TT> and <TT>double</TT> for most 
purposes, and <TT>long int</TT> any time we need to hold values 
greater than 32,767.
We'll rarely use individual variables of type <TT>char</TT>;
although we'll use plenty of arrays of <TT>char</TT>.
Types <TT>short int</TT> and <TT>float</TT> are important primarily when 
efficiency (speed or memory usage) is a concern,
and for us it usually won't be.
</p><p>Note that even when we're manipulating individual characters,
we'll usually use an <TT>int</TT> variable,
for the reason discussed in section 1.5.1
on page 16.
<br></p><hr>
<p>
Read sequentially:
<a href="sx5a.html" rev=precedes>prev</a>
<a href="sx5c.html" rel=precedes>next</a>
<a href="sx5.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
